open OrderedType

type __ = Obj.t
let __ = let rec f _ = Obj.repr f in Obj.repr f

type 'key coq_FMap = { empty : (__ -> __); is_empty : (__ -> __ -> bool);
                       mem : (__ -> 'key -> __ -> bool);
                       add : (__ -> 'key -> __ -> __ -> __);
                       find : (__ -> 'key -> __ -> __ option);
                       remove : (__ -> 'key -> __ -> __);
                       equal : (__ -> (__ -> __ -> bool) -> __ -> __ -> bool);
                       map : (__ -> __ -> (__ -> __) -> __ -> __);
                       mapi : (__ -> __ -> ('key -> __ -> __) -> __ -> __);
                       map2 : (__ -> __ -> __ -> (__ option -> __ option ->
                              __ option) -> __ -> __ -> __);
                       fold : (__ -> __ -> ('key -> __ -> __ -> __) -> __ ->
                              __ -> __); cardinal : (__ -> __ -> int);
                       elements : (__ -> __ -> ('key * __) list);
                       insert : (__ -> 'key -> __ -> (__ -> __) -> __ -> __);
                       adjust : (__ -> 'key -> (__ -> __) -> __ -> __);
                       coq_FMap_OrderedType : (__ -> __ coq_OrderedType -> __
                                              coq_OrderedType) }

type ('key, 'elt) dict = __

(** val empty : 'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict **)

let empty h fMap =
  fMap.empty __

(** val is_empty :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> bool **)

let is_empty h fMap x =
  fMap.is_empty __ x

(** val mem :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> ('a1, 'a2) dict -> bool **)

let mem h fMap x x0 =
  fMap.mem __ x x0

(** val add :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> 'a2 -> ('a1, 'a2) dict ->
    ('a1, 'a2) dict **)

let add h fMap x x0 x1 =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0; find =
    find0; remove = remove0; equal = equal0; map = map0; mapi = mapi0; map2 =
    map3; fold = fold0; cardinal = cardinal0; elements = elements0; insert =
    insert0; adjust = adjust0; coq_FMap_OrderedType = fMap_OrderedType } =
    fMap
  in
  Obj.magic add0 __ x x0 x1

(** val find :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> ('a1, 'a2) dict -> 'a2
    option **)

let find h fMap x x0 =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0; find =
    find0; remove = remove0; equal = equal0; map = map0; mapi = mapi0; map2 =
    map3; fold = fold0; cardinal = cardinal0; elements = elements0; insert =
    insert0; adjust = adjust0; coq_FMap_OrderedType = fMap_OrderedType } =
    fMap
  in
  Obj.magic find0 __ x x0

(** val remove :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> 'a1 -> ('a1, 'a2) dict -> ('a1,
    'a2) dict **)

let remove h fMap x x0 =
  fMap.remove __ x x0

(** val map :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 -> 'a3) -> ('a1, 'a2) dict ->
    ('a1, 'a3) dict **)

let map h fMap x x0 =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0; find =
    find0; remove = remove0; equal = equal0; map = map0; mapi = mapi0; map2 =
    map3; fold = fold0; cardinal = cardinal0; elements = elements0; insert =
    insert0; adjust = adjust0; coq_FMap_OrderedType = fMap_OrderedType } =
    fMap
  in
  Obj.magic map0 __ __ x x0

(** val map2 :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a2 option -> 'a3 option -> 'a4
    option) -> ('a1, 'a2) dict -> ('a1, 'a3) dict -> ('a1, 'a4) dict **)

let map2 h fMap x x0 x1 =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0; find =
    find0; remove = remove0; equal = equal0; map = map0; mapi = mapi0; map2 =
    map3; fold = fold0; cardinal = cardinal0; elements = elements0; insert =
    insert0; adjust = adjust0; coq_FMap_OrderedType = fMap_OrderedType } =
    fMap
  in
  Obj.magic map3 __ __ __ x x0 x1

(** val fold :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1 -> 'a2 -> 'a3 -> 'a3) ->
    ('a1, 'a2) dict -> 'a3 -> 'a3 **)

let fold h fMap x x0 x1 =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0; find =
    find0; remove = remove0; equal = equal0; map = map0; mapi = mapi0; map2 =
    map3; fold = fold0; cardinal = cardinal0; elements = elements0; insert =
    insert0; adjust = adjust0; coq_FMap_OrderedType = fMap_OrderedType } =
    fMap
  in
  Obj.magic fold0 __ __ x x0 x1

(** val cardinal :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> int **)

let cardinal h fMap x =
  fMap.cardinal __ x

(** val elements :
    'a1 coq_OrderedType -> 'a1 coq_FMap -> ('a1, 'a2) dict -> ('a1 * 'a2)
    list **)

let elements h fMap x =
  let { empty = empty0; is_empty = is_empty0; mem = mem0; add = add0; find =
    find0; remove = remove0; equal = equal0; map = map0; mapi = mapi0; map2 =
    map3; fold = fold0; cardinal = cardinal0; elements = elements0; insert =
    insert0; adjust = adjust0; coq_FMap_OrderedType = fMap_OrderedType } =
    fMap
  in
  Obj.magic elements0 __ x

