open Datatypes
open OrderedType

(** val asym_prod_compare :
    'a1 coq_OrderedType -> ('a1 * 'a2) -> ('a1 * 'a2) -> comparison **)

let asym_prod_compare h x y =
  compare h (fst x) (fst y)

(** val asym_prod_OrderedType :
    'a1 coq_OrderedType -> ('a1 * 'a2) coq_OrderedType **)

let asym_prod_OrderedType h =
  asym_prod_compare h

(** val list_compare :
    'a1 coq_OrderedType -> 'a1 list -> 'a1 list -> comparison **)

let rec list_compare h x y =
  match x with
  | [] ->
    (match y with
     | [] -> Eq
     | a :: l -> Lt)
  | a :: l ->
    (match y with
     | [] -> Gt
     | a' :: l' ->
       (match compare h a a' with
        | Eq -> list_compare h l l'
        | x0 -> x0))

(** val list_OrderedType :
    'a1 coq_OrderedType -> 'a1 list coq_OrderedType **)

let list_OrderedType h =
  list_compare h

