open Datatypes
open DomAbsValue
open DomBasic
open DomMap
open DomSet
open DomType
open MapInterface
open SetInterface

type accT = { callfroms : (fidT, (fidT * bidT) set) dict;
              callfroms_star : (fidT, fidT set) dict;
              acclocs : (fidT, locT set) dict }

val callfroms : accT -> (fidT, (fidT * bidT) set) dict

val callfroms_star : accT -> (fidT, fidT set) dict

val acclocs : accT -> (fidT, locT set) dict

val not_recursive : accT -> fidT -> bool

val is_strong : accT -> locT -> bool

