open DomBasic
open DomBridge
open DomType
open MapAVLInstance
open MapInterface
open Maps
open Ssrbool

val map_forall :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1 -> 'a2 ->
  bool) -> ('a1, 'a2) dict -> bool

val map_elt_compare :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a2 option ->
  'a2 option -> bool) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> bool

val map_elt_compareP :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a2 option ->
  'a2 option -> bool) -> ('a1, 'a2) dict -> ('a1, 'a2) dict -> reflect

val coerce : 'a1 setoid -> 'a1 poset -> 'a1 hasBot -> 'a1 option -> 'a1

val map_setoid :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> ('a1, 'a2) dict setoid

val map_poset :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> ('a1, 'a2) dict poset

val map_maplike :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> ('a1, 'a2, ('a1, 'a2) dict) maplike

val map_hasBot :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> ('a1, 'a2) dict hasBot

val map_setoidDec_obligation_2 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> ('a1, 'a2) dict -> ('a1, 'a2)
  dict -> reflect

val map_setoidDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> ('a1, 'a2) dict setoidDec

val map_posetDec_obligation_2 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> 'a2 posetDec -> ('a1, 'a2) dict
  -> ('a1, 'a2) dict -> reflect

val map_posetDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> 'a2 setoidDec -> 'a2 posetDec -> ('a1, 'a2) dict
  posetDec

val map_hasJoin :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> 'a2 hasJoin -> ('a1, 'a2) dict hasJoin

val map_mrestrict :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 powerset ->
  ('a1, 'a2) dict -> ('a1, 'a2) dict

val map_restricting_maplike :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a2 setoid ->
  'a2 poset -> 'a2 hasBot -> ('a1, 'a2, ('a1, 'a2) dict) restricting_maplike

