open DomBasic
open DomBridge
open DomType
open SetAVLInstance
open SetInterface
open Ssrbool

val set_setoid :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set setoid

val set_setlike :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1, 'a1 set)
  setlike

val set_forall :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1 -> bool)
  -> 'a1 set -> bool

val map :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> ('a1, 'a1)
  morphism -> 'a1 set -> 'a1 set

val set_poset :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set poset

val set_hasBot :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set hasBot

val set_hasJoin :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set hasJoin

val set_setoidDec_obligation_1 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set -> 'a1
  set -> reflect

val set_setoidDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
  setoidDec

val set_posetDec_obligation_1 :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set -> 'a1
  set -> reflect

val set_posetDec :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set
  posetDec

val set_to_powerset :
  'a1 setoid -> 'a1 poset -> 'a1 setoidDec -> 'a1 posetDec -> 'a1 set -> 'a1
  powerset

